﻿using System;
using Telerik.OpenAccess.Metadata.Fluent;
using Telerik.OpenAccess.Metadata;

namespace AuditTrailExample
{
    public class Audit
    {
        public enum AuditAction
        {
            Insert,
            Update,
            Delete
        }

        public int Id { get; set; }//id of audit object
        public string ObjectId { get; set; } //id of object being audited
        public AuditAction Action { get; set; }
        public string ClassName { get; set; }
        public string TableName { get; set; }
        public string OldData {get;set;}
        public string NewData { get; set; }
        public DateTime AuditDate { get; set; }

        public override string ToString()
        {
            return string.Format("Audit: '{2}' executed on ({0})-{1}", ClassName, Id, Action);
        }

        public static MappingConfiguration GetMapping()
        {
            var md = new MappingConfiguration<Audit>();
            md.HasProperty(a => a.Id).IsIdentity(KeyGenerator.Autoinc);
            md.MapType(x => new
                {
                    Id = x.Id,
                    ObjectId = x.ObjectId,
                    Action = x.Action,
                    ClassName = x.ClassName,
                    TableName = x.TableName,
                    OldData = x.OldData,
                    NewData = x.NewData,
                    AuditDate = x.AuditDate
                }).ToTable("Audits");
            return md;
        }
    }
}
